#!/usr/bin/perl

##############################################################################
# Nome: weather.pl
# Versione: 0.02
# Autore: Andrea Boscolo
# Sito web: http://www.andreaboscolo.it
# E-mail: info@andreaboscolo.it
#
# Questo programma controlla su Yahoo! Italia le condizioni atmosferiche e
# restituisce o la temperatura corrente in celsius o la condizione atmosferica
# Quest'ultima per essere usata con conky è codificata come segue:
#
# c: Parzialmente nuvoloso
# A: Bel tempo
# A: Soleggiato
# e: Molto nuvoloso
# e: Nebbia
# k: Nevicate
# g: Deboli piogge
#
# Questo programma è configurato per visualizare la temperatura e le
# condizioni atmosferiche di Venezia. Per visualizzare le misurazioni della
# propria città, o in alternativa di una città vicina, proseguire così:
# - aprire un browser (per esempio firefox)
# - andare all'inrizzo web: http://it.weather.yahoo.com
# - inserire il nome della propria città e premre cerca
#   (se non viene trovato provate con il capoluogo di provicina)
# - una volta visualizzata la situazione meteo della città ricercata, copiare
#   l'url della pagina sostituendolo a quello già presente nella sezione
#   "Configurazione"
# - provare il programma da riga di comando con:
#   $: ./weather.pl temp
#   $: ./weather.pl cond
# - se non viene stampato nulla a video controllate di essere connessi ad
#   Internet e di aver inserito correttamente l'url
#
# Licenza:
# Fetene quel che volete!
#
# Roadmap: nessuna
# Changelog:nessuno
#
##############################################################################

##############################################################################
# Configurazione
#
# url di Yahoo! Italia con il meteo della proprio città con gradi in celsius
# Es. per Venezia:
# $url = 'http://it.weather.yahoo.com/ITXX/ITXX0085/index_c.html';
#
$url = 'http://it.weather.yahoo.com/ITXX/ITXX0085/index_c.html';
##############################################################################

# carico il necessario
use LWP::Simple;
use Switch;

# controllo i parametri della riga di comando
if (($ARGV[0] ne 'temp') && ($ARGV[0] ne 'cond')) {
  print "Utilizzo: weather.pl [temp|cond]\n";
  exit;
}

# carico la pagina
$html = get($url);

# divido l'html della pagina 
@content = split(/\n/, $html);

# processo l'html
foreach $i (@content) {
  
  # devo controllare la temperatura?
  if ($ARGV[0] eq 'temp') {
    
    # leggo la temperatura
    if ($i =~ /.+<b>(\d+)&#176;<\/b>.+/) {
      # stampo la temperatura
      print $1;
    }
  }

  # devo controllare le condizioni atmosferiche?
  if ($ARGV[0] eq 'cond') {
    
    # le condizioni atmosferiche sono sulla stessa riga della temperatura
    if ($i =~ /.+<b>(\d+)&#176;<\/b>.+/) {
      
      # leggo la condizione atmosferica
      if ($i =~ /<br> <font size=-2 face="Arial,Helvetica">(.+?)<\/font><\/td>/) {
        
        # ritorno la lettera corrispondente alla condizione atmosferica
        switch ($1) {
          case 'Bel tempo'             { print 'A'; }
          case 'Soleggiato'            { print 'A'; }
          case 'Parzialmente nuvoloso' { print 'c'; }
          case 'Nebbia'                { print 'e'; }
          case 'Molto nuvoloso'        { print 'e'; } 
          case 'Nevicate'              { print 'k'; } 
          case 'Deboli piogge'         { print 'g'; } 
        }
      }
    }
  }
}

# esco 
exit;
